net.minecraft.client.renderer

## Class RenderBlocks

- java.lang.Object
- - net.minecraft.client.renderer.RenderBlocks

-     public class RenderBlocks
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `int` | `aoBrightnessXYNN` Ambient occlusion brightness XYNN
    `int` | `aoBrightnessXYNP` Ambient occlusion brightness XYNP
    `int` | `aoBrightnessXYPN` Ambient occlusion brightness XYPN
    `int` | `aoBrightnessXYPP` Ambient occlusion brightness XYPP
    `int` | `aoBrightnessXYZNNN` Ambient occlusion brightness XYZNNN
    `int` | `aoBrightnessXYZNNP` Ambient occlusion brightness XYZNNP
    `int` | `aoBrightnessXYZNPN` Ambient occlusion brightness XYZNPN
    `int` | `aoBrightnessXYZNPP` Ambient occlusion brightness XYZNPP
    `int` | `aoBrightnessXYZPNN` Ambient occlusion brightness XYZPNN
    `int` | `aoBrightnessXYZPNP` Ambient occlusion brightness XYZPNP
    `int` | `aoBrightnessXYZPPN` Ambient occlusion brightness XYZPPN
    `int` | `aoBrightnessXYZPPP` Ambient occlusion brightness XYZPPP
    `int` | `aoBrightnessXZNN` Ambient occlusion brightness XZNN
    `int` | `aoBrightnessXZNP` Ambient occlusion brightness XZNP
    `int` | `aoBrightnessXZPN` Ambient occlusion brightness XZPN
    `int` | `aoBrightnessXZPP` Ambient occlusion brightness XZPP
    `int` | `aoBrightnessYZNN` Ambient occlusion brightness YZNN
    `int` | `aoBrightnessYZNP` Ambient occlusion brightness YZNP
    `int` | `aoBrightnessYZPN` Ambient occlusion brightness YZPN
    `int` | `aoBrightnessYZPP` Ambient occlusion brightness YZPP
    `float` | `aoLightValueScratchXYNN` Used as a scratch variable for ambient occlusion between the bottom face and the north face.
    `float` | `aoLightValueScratchXYNP` Used as a scratch variable for ambient occlusion between the top face and the north face.
    `float` | `aoLightValueScratchXYPN` Used as a scratch variable for ambient occlusion between the bottom face and the south face.
    `float` | `aoLightValueScratchXYPP` Used as a scratch variable for ambient occlusion between the top face and the south face.
    `float` | `aoLightValueScratchXYZNNN` Used as a scratch variable for ambient occlusion on the north/bottom/east corner.
    `float` | `aoLightValueScratchXYZNNP` Used as a scratch variable for ambient occlusion on the north/bottom/west corner.
    `float` | `aoLightValueScratchXYZNPN` Used as a scratch variable for ambient occlusion on the north/top/east corner.
    `float` | `aoLightValueScratchXYZNPP` Used as a scratch variable for ambient occlusion on the north/top/west corner.
    `float` | `aoLightValueScratchXYZPNN` Used as a scratch variable for ambient occlusion on the south/bottom/east corner.
    `float` | `aoLightValueScratchXYZPNP` Used as a scratch variable for ambient occlusion on the south/bottom/west corner.
    `float` | `aoLightValueScratchXYZPPN` Used as a scratch variable for ambient occlusion on the south/top/east corner.
    `float` | `aoLightValueScratchXYZPPP` Used as a scratch variable for ambient occlusion on the south/top/west corner.
    `float` | `aoLightValueScratchXZNN` Used as a scratch variable for ambient occlusion between the north face and the east face.
    `float` | `aoLightValueScratchXZNP` Used as a scratch variable for ambient occlusion between the north face and the west face.
    `float` | `aoLightValueScratchXZPN` Used as a scratch variable for ambient occlusion between the south face and the east face.
    `float` | `aoLightValueScratchXZPP` Used as a scratch variable for ambient occlusion between the south face and the west face.
    `float` | `aoLightValueScratchYZNN` Used as a scratch variable for ambient occlusion between the bottom face and the east face.
    `float` | `aoLightValueScratchYZNP` Used as a scratch variable for ambient occlusion between the bottom face and the west face.
    `float` | `aoLightValueScratchYZPN` Used as a scratch variable for ambient occlusion between the top face and the east face.
    `float` | `aoLightValueScratchYZPP` Used as a scratch variable for ambient occlusion between the top face and the west face.
    `IBlockAccess` | `blockAccess` The IBlockAccess used by this instance of RenderBlocks
    `int` | `brightnessBottomLeft` Brightness bottom left
    `int` | `brightnessBottomRight` Brightness bottom right
    `int` | `brightnessTopLeft` Brightness top left
    `int` | `brightnessTopRight` Brightness top right
    `float` | `colorBlueBottomLeft` Blue color value for the bottom left corner
    `float` | `colorBlueBottomRight` Blue color value for the bottom right corner
    `float` | `colorBlueTopLeft` Blue color value for the top left corner
    `float` | `colorBlueTopRight` Blue color value for the top right corner
    `float` | `colorGreenBottomLeft` Green color value for the bottom left corner
    `float` | `colorGreenBottomRight` Green color value for the bottom right corner
    `float` | `colorGreenTopLeft` Green color value for the top left corner
    `float` | `colorGreenTopRight` Green color value for the top right corner
    `float` | `colorRedBottomLeft` Red color value for the bottom left corner
    `float` | `colorRedBottomRight` Red color value for the bottom right corner
    `float` | `colorRedTopLeft` Red color value for the top left corner
    `float` | `colorRedTopRight` Red color value for the top right corner
    `boolean` | `enableAO` Whether ambient occlusion is enabled or not
    `static boolean` | `fancyGrass` Fancy grass side matching biome
    `boolean` | `flipTexture` Set to true if the texture should be flipped horizontally during render*Face
    `boolean` | `lockBlockBounds` Set by overrideBlockBounds, to keep this class from changing the visual bounding box.
    `Minecraft` | `minecraftRB`
    `Icon` | `overrideBlockTexture` If set to >=0, all block faces will be rendered using this texture index
    `boolean` | `partialRenderBounds`
    `boolean` | `renderAllFaces` If true, renders all faces on all blocks rather than using the logic in Block.shouldSideBeRendered.
    `double` | `renderMaxX` The maximum X value for rendering (default 1.0).
    `double` | `renderMaxY` The maximum Y value for rendering (default 1.0).
    `double` | `renderMaxZ` The maximum Z value for rendering (default 1.0).
    `double` | `renderMinX` The minimum X value for rendering (default 0.0).
    `double` | `renderMinY` The minimum Y value for rendering (default 0.0).
    `double` | `renderMinZ` The minimum Z value for rendering (default 0.0).
    `boolean` | `useInventoryTint`
    `int` | `uvRotateBottom`
    `int` | `uvRotateEast`
    `int` | `uvRotateNorth`
    `int` | `uvRotateSouth`
    `int` | `uvRotateTop`
    `int` | `uvRotateWest`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RenderBlocks()`
    `RenderBlocks(IBlockAccess par1IBlockAccess)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearOverrideBlockTexture()` Clear override block texture
    `void` | `drawCrossedSquares(Block par1Block, int par2, double par3, double par5, double par7, float par9)` Utility function to draw crossed swuares
    `boolean` | `func_102027_b(Block par1Block, int par2, int par3, int par4, float par5, float par6, float par7)`
    `int` | `getAoBrightness(int par1, int par2, int par3, int par4)` Get ambient occlusion brightness
    `Icon` | `getBlockIcon(Block par1Block)`
    `Icon` | `getBlockIcon(Block par1Block, IBlockAccess par2IBlockAccess, int par3, int par4, int par5, int par6)`
    `Icon` | `getBlockIconFromSide(Block par1Block, int par2)`
    `Icon` | `getBlockIconFromSideAndMetadata(Block par1Block, int par2, int par3)`
    `float` | `getFluidHeight(int par1, int par2, int par3, Material par4Material)` Get fluid height
    `Icon` | `getIconSafe(Icon par1Icon)`
    `boolean` | `hasOverrideBlockTexture()`
    `int` | `mixAoBrightness(int par1, int par2, int par3, int par4, double par5, double par7, double par9, double par11)`
    `void` | `overrideBlockBounds(double par1, double par3, double par5, double par7, double par9, double par11)` Like setRenderBounds, but locks the values so that RenderBlocks won't change them.
    `void` | `renderBlockAllFaces(Block par1Block, int par2, int par3, int par4)` Render all faces of a block
    `boolean` | `renderBlockAnvil(BlockAnvil par1BlockAnvil, int par2, int par3, int par4)` Renders anvil
    `boolean` | `renderBlockAnvilMetadata(BlockAnvil par1BlockAnvil, int par2, int par3, int par4, int par5)` Renders anvil block with metadata
    `boolean` | `renderBlockAnvilOrient(BlockAnvil par1BlockAnvil, int par2, int par3, int par4, int par5, boolean par6)` Renders anvil block with orientation
    `float` | `renderBlockAnvilRotate(BlockAnvil par1BlockAnvil, int par2, int par3, int par4, int par5, float par6, float par7, float par8, float par9, boolean par10, boolean par11, int par12)` Renders anvil block with rotation
    `void` | `renderBlockAsItem(Block par1Block, int par2, float par3)` Is called to render the image of a block on an inventory, as a held item, or as a an item on the ground
    `boolean` | `renderBlockBeacon(BlockBeacon par1BlockBeacon, int par2, int par3, int par4)` Renders beacon block
    `boolean` | `renderBlockBed(Block par1Block, int par2, int par3, int par4)` render a bed at the given coordinates
    `boolean` | `renderBlockBrewingStand(BlockBrewingStand par1BlockBrewingStand, int par2, int par3, int par4)` Render BlockBrewingStand
    `boolean` | `renderBlockByRenderType(Block par1Block, int par2, int par3, int par4)` Renders the block at the given coordinates using the block's rendering type
    `boolean` | `renderBlockCactus(Block par1Block, int par2, int par3, int par4)` Renders a cactus block at the given coordinates
    `boolean` | `renderBlockCactusImpl(Block par1Block, int par2, int par3, int par4, float par5, float par6, float par7)` Render block cactus implementation
    `boolean` | `renderBlockCauldron(BlockCauldron par1BlockCauldron, int par2, int par3, int par4)` Render block cauldron
    `boolean` | `renderBlockCocoa(BlockCocoa par1BlockCocoa, int par2, int par3, int par4)` Renders a Cocoa block at the given coordinates
    `boolean` | `renderBlockComparator(BlockComparator par1BlockComparator, int par2, int par3, int par4)`
    `boolean` | `renderBlockCrops(Block par1Block, int par2, int par3, int par4)` Render block crops
    `void` | `renderBlockCropsImpl(Block par1Block, int par2, double par3, double par5, double par7)` Render block crops implementation
    `boolean` | `renderBlockDoor(Block par1Block, int par2, int par3, int par4)` Renders a door block at the given coordinates
    `boolean` | `renderBlockDragonEgg(BlockDragonEgg par1BlockDragonEgg, int par2, int par3, int par4)`
    `boolean` | `renderBlockEndPortalFrame(BlockEndPortalFrame par1BlockEndPortalFrame, int par2, int par3, int par4)` Render BlockEndPortalFrame
    `boolean` | `renderBlockFence(BlockFence par1BlockFence, int par2, int par3, int par4)`
    `boolean` | `renderBlockFenceGate(BlockFenceGate par1BlockFenceGate, int par2, int par3, int par4)` Render block fence gate
    `boolean` | `renderBlockFire(BlockFire par1BlockFire, int par2, int par3, int par4)` Renders a fire block at the given coordinates
    `boolean` | `renderBlockFlowerpot(BlockFlowerPot par1BlockFlowerPot, int par2, int par3, int par4)` Renders flower pot
    `boolean` | `renderBlockFluids(Block par1Block, int par2, int par3, int par4)` Renders a block based on the BlockFluids class at the given coordinates
    `boolean` | `renderBlockHopper(BlockHopper par1BlockHopper, int par2, int par3, int par4)`
    `boolean` | `renderBlockHopperMetadata(BlockHopper par1BlockHopper, int par2, int par3, int par4, int par5, boolean par6)`
    `boolean` | `renderBlockLadder(Block par1Block, int par2, int par3, int par4)` Renders a ladder block at the given coordinates
    `boolean` | `renderBlockLever(Block par1Block, int par2, int par3, int par4)` Renders a lever block at the given coordinates
    `boolean` | `renderBlockLilyPad(Block par1Block, int par2, int par3, int par4)` Render BlockLilyPad
    `boolean` | `renderBlockLog(Block par1Block, int par2, int par3, int par4)` Renders a log block at the given coordinates
    `boolean` | `renderBlockMinecartTrack(BlockRailBase par1BlockRailBase, int par2, int par3, int par4)` Renders a minecart track block at the given coordinates
    `boolean` | `renderBlockPane(BlockPane par1BlockPane, int par2, int par3, int par4)`
    `boolean` | `renderBlockQuartz(Block par1Block, int par2, int par3, int par4)`
    `boolean` | `renderBlockRedstoneLogic(BlockRedstoneLogic par1BlockRedstoneLogic, int par2, int par3, int par4)`
    `void` | `renderBlockRedstoneLogicMetadata(BlockRedstoneLogic par1BlockRedstoneLogic, int par2, int par3, int par4, int par5)`
    `boolean` | `renderBlockRedstoneWire(Block par1Block, int par2, int par3, int par4)` Renders a redstone wire block at the given coordinates
    `boolean` | `renderBlockRepeater(BlockRedstoneRepeater par1BlockRedstoneRepeater, int par2, int par3, int par4)` render a redstone repeater at the given coordinates
    `void` | `renderBlockSandFalling(Block par1Block, World par2World, int par3, int par4, int par5, int par6)` Renders a falling sand block
    `boolean` | `renderBlockStairs(BlockStairs par1BlockStairs, int par2, int par3, int par4)` Renders a stair block at the given coordinates
    `boolean` | `renderBlockStem(Block par1Block, int par2, int par3, int par4)` Render block stem
    `void` | `renderBlockStemBig(BlockStem par1BlockStem, int par2, int par3, double par4, double par6, double par8, double par10)` Render block stem big
    `void` | `renderBlockStemSmall(Block par1Block, int par2, double par3, double par5, double par7, double par9)` Render block stem small
    `boolean` | `renderBlockTorch(Block par1Block, int par2, int par3, int par4)` Renders a torch block at the given coordinates
    `boolean` | `renderBlockTripWire(Block par1Block, int par2, int par3, int par4)` Renders a trip wire block at the given coordinates
    `boolean` | `renderBlockTripWireSource(Block par1Block, int par2, int par3, int par4)` Renders a trip wire source block at the given coordinates
    `void` | `renderBlockUsingTexture(Block par1Block, int par2, int par3, int par4, Icon par5Icon)` Renders a block using the given texture instead of the block's own default texture
    `boolean` | `renderBlockVine(Block par1Block, int par2, int par3, int par4)` Render block vine
    `boolean` | `renderBlockWall(BlockWall par1BlockWall, int par2, int par3, int par4)` Renders wall block
    `void` | `renderBottomFace(Block par1Block, double par2, double par4, double par6, Icon par8Icon)` Renders the given texture to the bottom face of the block.
    `boolean` | `renderCrossedSquares(Block par1Block, int par2, int par3, int par4)` Renders any block requiring croseed squares such as reeds, flowers, and mushrooms
    `void` | `renderEastFace(Block par1Block, double par2, double par4, double par6, Icon par8Icon)` Renders the given texture to the east (z-negative) face of the block.
    `static boolean` | `renderItemIn3d(int par0)` Checks to see if the item's render type indicates that it should be rendered as a regular block or not.
    `void` | `renderNorthFace(Block par1Block, double par2, double par4, double par6, Icon par8Icon)` Renders the given texture to the north (x-negative) face of the block.
    `boolean` | `renderPistonBase(Block par1Block, int par2, int par3, int par4, boolean par5)` renders a block as a piston base
    `void` | `renderPistonBaseAllFaces(Block par1Block, int par2, int par3, int par4)` Render all faces of the piston base
    `boolean` | `renderPistonExtension(Block par1Block, int par2, int par3, int par4, boolean par5)` renders the pushing part of a piston
    `void` | `renderPistonExtensionAllFaces(Block par1Block, int par2, int par3, int par4, boolean par5)` Render all faces of the piston extension
    `void` | `renderPistonRodEW(double par1, double par3, double par5, double par7, double par9, double par11, float par13, double par14)` Render piston rod east/west
    `void` | `renderPistonRodSN(double par1, double par3, double par5, double par7, double par9, double par11, float par13, double par14)` Render piston rod south/north
    `void` | `renderPistonRodUD(double par1, double par3, double par5, double par7, double par9, double par11, float par13, double par14)` Render piston rod up/down
    `void` | `renderSouthFace(Block par1Block, double par2, double par4, double par6, Icon par8Icon)` Renders the given texture to the south (x-positive) face of the block.
    `boolean` | `renderStandardBlock(Block par1Block, int par2, int par3, int par4)` Renders a standard cube block at the given coordinates
    `boolean` | `renderStandardBlockWithAmbientOcclusion(Block par1Block, int par2, int par3, int par4, float par5, float par6, float par7)`
    `boolean` | `renderStandardBlockWithColorMultiplier(Block par1Block, int par2, int par3, int par4, float par5, float par6, float par7)` Renders a standard cube block at the given coordinates, with a given color ratio.
    `void` | `renderTopFace(Block par1Block, double par2, double par4, double par6, Icon par8Icon)` Renders the given texture to the top face of the block.
    `void` | `renderTorchAtAngle(Block par1Block, double par2, double par4, double par6, double par8, double par10, int par12)` Renders a torch at the given coordinates, with the base slanting at the given delta
    `void` | `renderWestFace(Block par1Block, double par2, double par4, double par6, Icon par8Icon)` Renders the given texture to the west (z-positive) face of the block.
    `void` | `setOverrideBlockTexture(Icon par1Icon)` Sets overrideBlockTexture
    `void` | `setRenderBounds(double par1, double par3, double par5, double par7, double par9, double par11)` Sets the bounding box for the block to draw in, e.g.
    `void` | `setRenderBoundsFromBlock(Block par1Block)` Like setRenderBounds, but automatically pulling the bounds from the given Block.
    `void` | `unlockBlockBounds()` Unlocks the visual bounding box so that RenderBlocks can change it again.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### blockAccess

          public IBlockAccess blockAccess

      The IBlockAccess used by this instance of RenderBlocks

    - #### overrideBlockTexture

          public Icon overrideBlockTexture

      If set to >=0, all block faces will be rendered using this texture index

    - #### flipTexture

          public boolean flipTexture

      Set to true if the texture should be flipped horizontally during render*Face

    - #### renderAllFaces

          public boolean renderAllFaces

      If true, renders all faces on all blocks rather than using the logic in Block.shouldSideBeRendered. Unused.

    - #### fancyGrass

          public static boolean fancyGrass

      Fancy grass side matching biome

    - #### useInventoryTint

          public boolean useInventoryTint

    - #### renderMinX

          public double renderMinX

      The minimum X value for rendering (default 0.0).

    - #### renderMaxX

          public double renderMaxX

      The maximum X value for rendering (default 1.0).

    - #### renderMinY

          public double renderMinY

      The minimum Y value for rendering (default 0.0).

    - #### renderMaxY

          public double renderMaxY

      The maximum Y value for rendering (default 1.0).

    - #### renderMinZ

          public double renderMinZ

      The minimum Z value for rendering (default 0.0).

    - #### renderMaxZ

          public double renderMaxZ

      The maximum Z value for rendering (default 1.0).

    - #### lockBlockBounds

          public boolean lockBlockBounds

      Set by overrideBlockBounds, to keep this class from changing the visual bounding box.

    - #### partialRenderBounds

          public boolean partialRenderBounds

    - #### minecraftRB

          public final Minecraft minecraftRB

    - #### uvRotateEast

          public int uvRotateEast

    - #### uvRotateWest

          public int uvRotateWest

    - #### uvRotateSouth

          public int uvRotateSouth

    - #### uvRotateNorth

          public int uvRotateNorth

    - #### uvRotateTop

          public int uvRotateTop

    - #### uvRotateBottom

          public int uvRotateBottom

    - #### enableAO

          public boolean enableAO

      Whether ambient occlusion is enabled or not

    - #### aoLightValueScratchXYZNNN

          public float aoLightValueScratchXYZNNN

      Used as a scratch variable for ambient occlusion on the north/bottom/east corner.

    - #### aoLightValueScratchXYNN

          public float aoLightValueScratchXYNN

      Used as a scratch variable for ambient occlusion between the bottom face and the north face.

    - #### aoLightValueScratchXYZNNP

          public float aoLightValueScratchXYZNNP

      Used as a scratch variable for ambient occlusion on the north/bottom/west corner.

    - #### aoLightValueScratchYZNN

          public float aoLightValueScratchYZNN

      Used as a scratch variable for ambient occlusion between the bottom face and the east face.

    - #### aoLightValueScratchYZNP

          public float aoLightValueScratchYZNP

      Used as a scratch variable for ambient occlusion between the bottom face and the west face.

    - #### aoLightValueScratchXYZPNN

          public float aoLightValueScratchXYZPNN

      Used as a scratch variable for ambient occlusion on the south/bottom/east corner.

    - #### aoLightValueScratchXYPN

          public float aoLightValueScratchXYPN

      Used as a scratch variable for ambient occlusion between the bottom face and the south face.

    - #### aoLightValueScratchXYZPNP

          public float aoLightValueScratchXYZPNP

      Used as a scratch variable for ambient occlusion on the south/bottom/west corner.

    - #### aoLightValueScratchXYZNPN

          public float aoLightValueScratchXYZNPN

      Used as a scratch variable for ambient occlusion on the north/top/east corner.

    - #### aoLightValueScratchXYNP

          public float aoLightValueScratchXYNP

      Used as a scratch variable for ambient occlusion between the top face and the north face.

    - #### aoLightValueScratchXYZNPP

          public float aoLightValueScratchXYZNPP

      Used as a scratch variable for ambient occlusion on the north/top/west corner.

    - #### aoLightValueScratchYZPN

          public float aoLightValueScratchYZPN

      Used as a scratch variable for ambient occlusion between the top face and the east face.

    - #### aoLightValueScratchXYZPPN

          public float aoLightValueScratchXYZPPN

      Used as a scratch variable for ambient occlusion on the south/top/east corner.

    - #### aoLightValueScratchXYPP

          public float aoLightValueScratchXYPP

      Used as a scratch variable for ambient occlusion between the top face and the south face.

    - #### aoLightValueScratchYZPP

          public float aoLightValueScratchYZPP

      Used as a scratch variable for ambient occlusion between the top face and the west face.

    - #### aoLightValueScratchXYZPPP

          public float aoLightValueScratchXYZPPP

      Used as a scratch variable for ambient occlusion on the south/top/west corner.

    - #### aoLightValueScratchXZNN

          public float aoLightValueScratchXZNN

      Used as a scratch variable for ambient occlusion between the north face and the east face.

    - #### aoLightValueScratchXZPN

          public float aoLightValueScratchXZPN

      Used as a scratch variable for ambient occlusion between the south face and the east face.

    - #### aoLightValueScratchXZNP

          public float aoLightValueScratchXZNP

      Used as a scratch variable for ambient occlusion between the north face and the west face.

    - #### aoLightValueScratchXZPP

          public float aoLightValueScratchXZPP

      Used as a scratch variable for ambient occlusion between the south face and the west face.

    - #### aoBrightnessXYZNNN

          public int aoBrightnessXYZNNN

      Ambient occlusion brightness XYZNNN

    - #### aoBrightnessXYNN

          public int aoBrightnessXYNN

      Ambient occlusion brightness XYNN

    - #### aoBrightnessXYZNNP

          public int aoBrightnessXYZNNP

      Ambient occlusion brightness XYZNNP

    - #### aoBrightnessYZNN

          public int aoBrightnessYZNN

      Ambient occlusion brightness YZNN

    - #### aoBrightnessYZNP

          public int aoBrightnessYZNP

      Ambient occlusion brightness YZNP

    - #### aoBrightnessXYZPNN

          public int aoBrightnessXYZPNN

      Ambient occlusion brightness XYZPNN

    - #### aoBrightnessXYPN

          public int aoBrightnessXYPN

      Ambient occlusion brightness XYPN

    - #### aoBrightnessXYZPNP

          public int aoBrightnessXYZPNP

      Ambient occlusion brightness XYZPNP

    - #### aoBrightnessXYZNPN

          public int aoBrightnessXYZNPN

      Ambient occlusion brightness XYZNPN

    - #### aoBrightnessXYNP

          public int aoBrightnessXYNP

      Ambient occlusion brightness XYNP

    - #### aoBrightnessXYZNPP

          public int aoBrightnessXYZNPP

      Ambient occlusion brightness XYZNPP

    - #### aoBrightnessYZPN

          public int aoBrightnessYZPN

      Ambient occlusion brightness YZPN

    - #### aoBrightnessXYZPPN

          public int aoBrightnessXYZPPN

      Ambient occlusion brightness XYZPPN

    - #### aoBrightnessXYPP

          public int aoBrightnessXYPP

      Ambient occlusion brightness XYPP

    - #### aoBrightnessYZPP

          public int aoBrightnessYZPP

      Ambient occlusion brightness YZPP

    - #### aoBrightnessXYZPPP

          public int aoBrightnessXYZPPP

      Ambient occlusion brightness XYZPPP

    - #### aoBrightnessXZNN

          public int aoBrightnessXZNN

      Ambient occlusion brightness XZNN

    - #### aoBrightnessXZPN

          public int aoBrightnessXZPN

      Ambient occlusion brightness XZPN

    - #### aoBrightnessXZNP

          public int aoBrightnessXZNP

      Ambient occlusion brightness XZNP

    - #### aoBrightnessXZPP

          public int aoBrightnessXZPP

      Ambient occlusion brightness XZPP

    - #### brightnessTopLeft

          public int brightnessTopLeft

      Brightness top left

    - #### brightnessBottomLeft

          public int brightnessBottomLeft

      Brightness bottom left

    - #### brightnessBottomRight

          public int brightnessBottomRight

      Brightness bottom right

    - #### brightnessTopRight

          public int brightnessTopRight

      Brightness top right

    - #### colorRedTopLeft

          public float colorRedTopLeft

      Red color value for the top left corner

    - #### colorRedBottomLeft

          public float colorRedBottomLeft

      Red color value for the bottom left corner

    - #### colorRedBottomRight

          public float colorRedBottomRight

      Red color value for the bottom right corner

    - #### colorRedTopRight

          public float colorRedTopRight

      Red color value for the top right corner

    - #### colorGreenTopLeft

          public float colorGreenTopLeft

      Green color value for the top left corner

    - #### colorGreenBottomLeft

          public float colorGreenBottomLeft

      Green color value for the bottom left corner

    - #### colorGreenBottomRight

          public float colorGreenBottomRight

      Green color value for the bottom right corner

    - #### colorGreenTopRight

          public float colorGreenTopRight

      Green color value for the top right corner

    - #### colorBlueTopLeft

          public float colorBlueTopLeft

      Blue color value for the top left corner

    - #### colorBlueBottomLeft

          public float colorBlueBottomLeft

      Blue color value for the bottom left corner

    - #### colorBlueBottomRight

          public float colorBlueBottomRight

      Blue color value for the bottom right corner

    - #### colorBlueTopRight

          public float colorBlueTopRight

      Blue color value for the top right corner

  - ### Constructor Detail

    - #### RenderBlocks

          public RenderBlocks(IBlockAccess par1IBlockAccess)

    - #### RenderBlocks

          public RenderBlocks()

  - ### Method Detail

    - #### setOverrideBlockTexture

          public void setOverrideBlockTexture(Icon par1Icon)

      Sets overrideBlockTexture

    - #### clearOverrideBlockTexture

          public void clearOverrideBlockTexture()

      Clear override block texture

    - #### hasOverrideBlockTexture

          public boolean hasOverrideBlockTexture()

    - #### setRenderBounds

          public void setRenderBounds(double par1,
                             double par3,
                             double par5,
                             double par7,
                             double par9,
                             double par11)

      Sets the bounding box for the block to draw in, e.g. 0.25-0.75 on all axes for a half-size, centered block.

    - #### setRenderBoundsFromBlock

          public void setRenderBoundsFromBlock(Block par1Block)

      Like setRenderBounds, but automatically pulling the bounds from the given Block.

    - #### overrideBlockBounds

          public void overrideBlockBounds(double par1,
                                 double par3,
                                 double par5,
                                 double par7,
                                 double par9,
                                 double par11)

      Like setRenderBounds, but locks the values so that RenderBlocks won't change them. If you use this, you must call unlockBlockBounds after you finish rendering!

    - #### unlockBlockBounds

          public void unlockBlockBounds()

      Unlocks the visual bounding box so that RenderBlocks can change it again.

    - #### renderBlockUsingTexture

          public void renderBlockUsingTexture(Block par1Block,
                                     int par2,
                                     int par3,
                                     int par4,
                                     Icon par5Icon)

      Renders a block using the given texture instead of the block's own default texture

    - #### renderBlockAllFaces

          public void renderBlockAllFaces(Block par1Block,
                                 int par2,
                                 int par3,
                                 int par4)

      Render all faces of a block

    - #### renderBlockByRenderType

          public boolean renderBlockByRenderType(Block par1Block,
                                        int par2,
                                        int par3,
                                        int par4)

      Renders the block at the given coordinates using the block's rendering type

    - #### renderBlockEndPortalFrame

          public boolean renderBlockEndPortalFrame(BlockEndPortalFrame par1BlockEndPortalFrame,
                                          int par2,
                                          int par3,
                                          int par4)

      Render BlockEndPortalFrame

    - #### renderBlockBed

          public boolean renderBlockBed(Block par1Block,
                               int par2,
                               int par3,
                               int par4)

      render a bed at the given coordinates

    - #### renderBlockBrewingStand

          public boolean renderBlockBrewingStand(BlockBrewingStand par1BlockBrewingStand,
                                        int par2,
                                        int par3,
                                        int par4)

      Render BlockBrewingStand

    - #### renderBlockCauldron

          public boolean renderBlockCauldron(BlockCauldron par1BlockCauldron,
                                    int par2,
                                    int par3,
                                    int par4)

      Render block cauldron

    - #### renderBlockFlowerpot

          public boolean renderBlockFlowerpot(BlockFlowerPot par1BlockFlowerPot,
                                     int par2,
                                     int par3,
                                     int par4)

      Renders flower pot

    - #### renderBlockAnvil

          public boolean renderBlockAnvil(BlockAnvil par1BlockAnvil,
                                 int par2,
                                 int par3,
                                 int par4)

      Renders anvil

    - #### renderBlockAnvilMetadata

          public boolean renderBlockAnvilMetadata(BlockAnvil par1BlockAnvil,
                                         int par2,
                                         int par3,
                                         int par4,
                                         int par5)

      Renders anvil block with metadata

    - #### renderBlockAnvilOrient

          public boolean renderBlockAnvilOrient(BlockAnvil par1BlockAnvil,
                                       int par2,
                                       int par3,
                                       int par4,
                                       int par5,
                                       boolean par6)

      Renders anvil block with orientation

    - #### renderBlockAnvilRotate

          public float renderBlockAnvilRotate(BlockAnvil par1BlockAnvil,
                                     int par2,
                                     int par3,
                                     int par4,
                                     int par5,
                                     float par6,
                                     float par7,
                                     float par8,
                                     float par9,
                                     boolean par10,
                                     boolean par11,
                                     int par12)

      Renders anvil block with rotation

    - #### renderBlockTorch

          public boolean renderBlockTorch(Block par1Block,
                                 int par2,
                                 int par3,
                                 int par4)

      Renders a torch block at the given coordinates

    - #### renderBlockRepeater

          public boolean renderBlockRepeater(BlockRedstoneRepeater par1BlockRedstoneRepeater,
                                    int par2,
                                    int par3,
                                    int par4)

      render a redstone repeater at the given coordinates

    - #### renderBlockComparator

          public boolean renderBlockComparator(BlockComparator par1BlockComparator,
                                      int par2,
                                      int par3,
                                      int par4)

    - #### renderBlockRedstoneLogic

          public boolean renderBlockRedstoneLogic(BlockRedstoneLogic par1BlockRedstoneLogic,
                                         int par2,
                                         int par3,
                                         int par4)

    - #### renderBlockRedstoneLogicMetadata

          public void renderBlockRedstoneLogicMetadata(BlockRedstoneLogic par1BlockRedstoneLogic,
                                              int par2,
                                              int par3,
                                              int par4,
                                              int par5)

    - #### renderPistonBaseAllFaces

          public void renderPistonBaseAllFaces(Block par1Block,
                                      int par2,
                                      int par3,
                                      int par4)

      Render all faces of the piston base

    - #### renderPistonBase

          public boolean renderPistonBase(Block par1Block,
                                 int par2,
                                 int par3,
                                 int par4,
                                 boolean par5)

      renders a block as a piston base

    - #### renderPistonRodUD

          public void renderPistonRodUD(double par1,
                               double par3,
                               double par5,
                               double par7,
                               double par9,
                               double par11,
                               float par13,
                               double par14)

      Render piston rod up/down

    - #### renderPistonRodSN

          public void renderPistonRodSN(double par1,
                               double par3,
                               double par5,
                               double par7,
                               double par9,
                               double par11,
                               float par13,
                               double par14)

      Render piston rod south/north

    - #### renderPistonRodEW

          public void renderPistonRodEW(double par1,
                               double par3,
                               double par5,
                               double par7,
                               double par9,
                               double par11,
                               float par13,
                               double par14)

      Render piston rod east/west

    - #### renderPistonExtensionAllFaces

          public void renderPistonExtensionAllFaces(Block par1Block,
                                           int par2,
                                           int par3,
                                           int par4,
                                           boolean par5)

      Render all faces of the piston extension

    - #### renderPistonExtension

          public boolean renderPistonExtension(Block par1Block,
                                      int par2,
                                      int par3,
                                      int par4,
                                      boolean par5)

      renders the pushing part of a piston

    - #### renderBlockLever

          public boolean renderBlockLever(Block par1Block,
                                 int par2,
                                 int par3,
                                 int par4)

      Renders a lever block at the given coordinates

    - #### renderBlockTripWireSource

          public boolean renderBlockTripWireSource(Block par1Block,
                                          int par2,
                                          int par3,
                                          int par4)

      Renders a trip wire source block at the given coordinates

    - #### renderBlockTripWire

          public boolean renderBlockTripWire(Block par1Block,
                                    int par2,
                                    int par3,
                                    int par4)

      Renders a trip wire block at the given coordinates

    - #### renderBlockFire

          public boolean renderBlockFire(BlockFire par1BlockFire,
                                int par2,
                                int par3,
                                int par4)

      Renders a fire block at the given coordinates

    - #### renderBlockRedstoneWire

          public boolean renderBlockRedstoneWire(Block par1Block,
                                        int par2,
                                        int par3,
                                        int par4)

      Renders a redstone wire block at the given coordinates

    - #### renderBlockMinecartTrack

          public boolean renderBlockMinecartTrack(BlockRailBase par1BlockRailBase,
                                         int par2,
                                         int par3,
                                         int par4)

      Renders a minecart track block at the given coordinates

    - #### renderBlockLadder

          public boolean renderBlockLadder(Block par1Block,
                                  int par2,
                                  int par3,
                                  int par4)

      Renders a ladder block at the given coordinates

    - #### renderBlockVine

          public boolean renderBlockVine(Block par1Block,
                                int par2,
                                int par3,
                                int par4)

      Render block vine

    - #### renderBlockPane

          public boolean renderBlockPane(BlockPane par1BlockPane,
                                int par2,
                                int par3,
                                int par4)

    - #### renderCrossedSquares

          public boolean renderCrossedSquares(Block par1Block,
                                     int par2,
                                     int par3,
                                     int par4)

      Renders any block requiring croseed squares such as reeds, flowers, and mushrooms

    - #### renderBlockStem

          public boolean renderBlockStem(Block par1Block,
                                int par2,
                                int par3,
                                int par4)

      Render block stem

    - #### renderBlockCrops

          public boolean renderBlockCrops(Block par1Block,
                                 int par2,
                                 int par3,
                                 int par4)

      Render block crops

    - #### renderTorchAtAngle

          public void renderTorchAtAngle(Block par1Block,
                                double par2,
                                double par4,
                                double par6,
                                double par8,
                                double par10,
                                int par12)

      Renders a torch at the given coordinates, with the base slanting at the given delta

    - #### drawCrossedSquares

          public void drawCrossedSquares(Block par1Block,
                                int par2,
                                double par3,
                                double par5,
                                double par7,
                                float par9)

      Utility function to draw crossed swuares

    - #### renderBlockStemSmall

          public void renderBlockStemSmall(Block par1Block,
                                  int par2,
                                  double par3,
                                  double par5,
                                  double par7,
                                  double par9)

      Render block stem small

    - #### renderBlockLilyPad

          public boolean renderBlockLilyPad(Block par1Block,
                                   int par2,
                                   int par3,
                                   int par4)

      Render BlockLilyPad

    - #### renderBlockStemBig

          public void renderBlockStemBig(BlockStem par1BlockStem,
                                int par2,
                                int par3,
                                double par4,
                                double par6,
                                double par8,
                                double par10)

      Render block stem big

    - #### renderBlockCropsImpl

          public void renderBlockCropsImpl(Block par1Block,
                                  int par2,
                                  double par3,
                                  double par5,
                                  double par7)

      Render block crops implementation

    - #### renderBlockFluids

          public boolean renderBlockFluids(Block par1Block,
                                  int par2,
                                  int par3,
                                  int par4)

      Renders a block based on the BlockFluids class at the given coordinates

    - #### getFluidHeight

          public float getFluidHeight(int par1,
                             int par2,
                             int par3,
                             Material par4Material)

      Get fluid height

    - #### renderBlockSandFalling

          public void renderBlockSandFalling(Block par1Block,
                                    World par2World,
                                    int par3,
                                    int par4,
                                    int par5,
                                    int par6)

      Renders a falling sand block

    - #### renderStandardBlock

          public boolean renderStandardBlock(Block par1Block,
                                    int par2,
                                    int par3,
                                    int par4)

      Renders a standard cube block at the given coordinates

    - #### renderBlockLog

          public boolean renderBlockLog(Block par1Block,
                               int par2,
                               int par3,
                               int par4)

      Renders a log block at the given coordinates

    - #### renderBlockQuartz

          public boolean renderBlockQuartz(Block par1Block,
                                  int par2,
                                  int par3,
                                  int par4)

    - #### renderStandardBlockWithAmbientOcclusion

          public boolean renderStandardBlockWithAmbientOcclusion(Block par1Block,
                                                        int par2,
                                                        int par3,
                                                        int par4,
                                                        float par5,
                                                        float par6,
                                                        float par7)

    - #### func_102027_b

          public boolean func_102027_b(Block par1Block,
                              int par2,
                              int par3,
                              int par4,
                              float par5,
                              float par6,
                              float par7)

    - #### getAoBrightness

          public int getAoBrightness(int par1,
                            int par2,
                            int par3,
                            int par4)

      Get ambient occlusion brightness

    - #### mixAoBrightness

          public int mixAoBrightness(int par1,
                            int par2,
                            int par3,
                            int par4,
                            double par5,
                            double par7,
                            double par9,
                            double par11)

    - #### renderStandardBlockWithColorMultiplier

          public boolean renderStandardBlockWithColorMultiplier(Block par1Block,
                                                       int par2,
                                                       int par3,
                                                       int par4,
                                                       float par5,
                                                       float par6,
                                                       float par7)

      Renders a standard cube block at the given coordinates, with a given color ratio. Args: block, x, y, z, r, g, b

    - #### renderBlockCocoa

          public boolean renderBlockCocoa(BlockCocoa par1BlockCocoa,
                                 int par2,
                                 int par3,
                                 int par4)

      Renders a Cocoa block at the given coordinates

    - #### renderBlockBeacon

          public boolean renderBlockBeacon(BlockBeacon par1BlockBeacon,
                                  int par2,
                                  int par3,
                                  int par4)

      Renders beacon block

    - #### renderBlockCactus

          public boolean renderBlockCactus(Block par1Block,
                                  int par2,
                                  int par3,
                                  int par4)

      Renders a cactus block at the given coordinates

    - #### renderBlockCactusImpl

          public boolean renderBlockCactusImpl(Block par1Block,
                                      int par2,
                                      int par3,
                                      int par4,
                                      float par5,
                                      float par6,
                                      float par7)

      Render block cactus implementation

    - #### renderBlockFence

          public boolean renderBlockFence(BlockFence par1BlockFence,
                                 int par2,
                                 int par3,
                                 int par4)

    - #### renderBlockWall

          public boolean renderBlockWall(BlockWall par1BlockWall,
                                int par2,
                                int par3,
                                int par4)

      Renders wall block

    - #### renderBlockDragonEgg

          public boolean renderBlockDragonEgg(BlockDragonEgg par1BlockDragonEgg,
                                     int par2,
                                     int par3,
                                     int par4)

    - #### renderBlockFenceGate

          public boolean renderBlockFenceGate(BlockFenceGate par1BlockFenceGate,
                                     int par2,
                                     int par3,
                                     int par4)

      Render block fence gate

    - #### renderBlockHopper

          public boolean renderBlockHopper(BlockHopper par1BlockHopper,
                                  int par2,
                                  int par3,
                                  int par4)

    - #### renderBlockHopperMetadata

          public boolean renderBlockHopperMetadata(BlockHopper par1BlockHopper,
                                          int par2,
                                          int par3,
                                          int par4,
                                          int par5,
                                          boolean par6)

    - #### renderBlockStairs

          public boolean renderBlockStairs(BlockStairs par1BlockStairs,
                                  int par2,
                                  int par3,
                                  int par4)

      Renders a stair block at the given coordinates

    - #### renderBlockDoor

          public boolean renderBlockDoor(Block par1Block,
                                int par2,
                                int par3,
                                int par4)

      Renders a door block at the given coordinates

    - #### renderBottomFace

          public void renderBottomFace(Block par1Block,
                              double par2,
                              double par4,
                              double par6,
                              Icon par8Icon)

      Renders the given texture to the bottom face of the block. Args: block, x, y, z, texture

    - #### renderTopFace

          public void renderTopFace(Block par1Block,
                           double par2,
                           double par4,
                           double par6,
                           Icon par8Icon)

      Renders the given texture to the top face of the block. Args: block, x, y, z, texture

    - #### renderEastFace

          public void renderEastFace(Block par1Block,
                            double par2,
                            double par4,
                            double par6,
                            Icon par8Icon)

      Renders the given texture to the east (z-negative) face of the block. Args: block, x, y, z, texture

    - #### renderWestFace

          public void renderWestFace(Block par1Block,
                            double par2,
                            double par4,
                            double par6,
                            Icon par8Icon)

      Renders the given texture to the west (z-positive) face of the block. Args: block, x, y, z, texture

    - #### renderNorthFace

          public void renderNorthFace(Block par1Block,
                             double par2,
                             double par4,
                             double par6,
                             Icon par8Icon)

      Renders the given texture to the north (x-negative) face of the block. Args: block, x, y, z, texture

    - #### renderSouthFace

          public void renderSouthFace(Block par1Block,
                             double par2,
                             double par4,
                             double par6,
                             Icon par8Icon)

      Renders the given texture to the south (x-positive) face of the block. Args: block, x, y, z, texture

    - #### renderBlockAsItem

          public void renderBlockAsItem(Block par1Block,
                               int par2,
                               float par3)

      Is called to render the image of a block on an inventory, as a held item, or as a an item on the ground

    - #### renderItemIn3d

          public static boolean renderItemIn3d(int par0)

      Checks to see if the item's render type indicates that it should be rendered as a regular block or not.

    - #### getBlockIcon

          public Icon getBlockIcon(Block par1Block,
                          IBlockAccess par2IBlockAccess,
                          int par3,
                          int par4,
                          int par5,
                          int par6)

    - #### getBlockIconFromSideAndMetadata

          public Icon getBlockIconFromSideAndMetadata(Block par1Block,
                                             int par2,
                                             int par3)

    - #### getBlockIconFromSide

          public Icon getBlockIconFromSide(Block par1Block,
                                  int par2)

    - #### getBlockIcon

          public Icon getBlockIcon(Block par1Block)

    - #### getIconSafe

          public Icon getIconSafe(Icon par1Icon)